#!/bin/sh

identify_type_by_name()
{
    case "$1" in
	pinentry-qt|pinentry-gtk)
	    echo "x11"
	    ;;
	pinentry-curses)
	    echo "console"
	    ;;
	*)
	    echo "unknown"
	    ;;
    esac
}

[ -n "${GNUPGHOME}" ] || GNUPGHOME="${HOME}/.gnupg"

if [ -r "${GNUPGHOME}/gpg.conf" ]
then
    CFG="${GNUPGHOME}/gpg.conf"
else
    CFG="${GNUPGHOME}/options"
fi

X11=no
if [ -r "${GNUPGHOME}/gpg-agent.conf" ]; then
    PNTRY_PRG_NAM=$(echo $(cat "${GNUPGHOME}/gpg-agent.conf"| grep pinentry-program| sed "s/.*\///g"))
    PNTRY_PRG_TYP=$(identify_type_by_name $PNTRY_PRG_NAM)
    if [ "$PNTRY_PRG_TYP" == "unknown" ]
    then
	PNTRY_PRG_NAM=$(echo $(/usr/sbin/alternatives-list -s /usr/bin/pinentry| grep -epoints.*to.*/usr/bin/pinentry| sed "s/.*\///g"))
	PNTRY_PRG_TYP=$(identify_type_by_name $PNTRY_PRG_NAM)
	[ "$PNTRY_PRG_TYP" == "x11" ] && X11=yes
    else
	[ "$PNTRY_PRG_TYP" == "x11" ] && X11=yes
    fi
fi

if grep -q "^use-agent" ${CFG} 2>/dev/null
then
    if [ -f "${GNUPGHOME}/GPG_AGENT_INFO" ] && kill -0 "$(cut -d: -f2 ${GNUPGHOME}/GPG_AGENT_INFO)" 2>/dev/null
    then
	export GPG_AGENT_INFO="$(cat ${GNUPGHOME}/GPG_AGENT_INFO)"
    else
	if [ -n "$DISPLAY" -a "$X11" = "yes" ] || [ -z "$DISPLAY" -a "$X11" = "no" ]
	then
	    eval "$(gpg-agent --daemon)"
	    echo $GPG_AGENT_INFO > ${GNUPGHOME}/GPG_AGENT_INFO
	fi
    fi
fi
